import 'dart:convert';
import 'package:flutter/services.dart';

class AppConfig {
  final String environment;
  final String contents;
  final String clientToken;
  final String clientSecretKey;
  final String clientCountry;
  final String clientDomain;

  AppConfig({
    required this.environment,
    required this.contents,
    required this.clientToken,
    required this.clientSecretKey,
    required this.clientCountry,
    required this.clientDomain,
  });

  static Future<AppConfig> forEnvironment(String env) async {
    // load the json file
    final contents = await rootBundle.loadString(
      'lib/assets/config/$env-retailer.json',
    );

    // decode our json
    final json = jsonDecode(contents);

    // convert our JSON into an instance of our AppConfig class
    return AppConfig(
      environment: env,
      contents: contents,
      clientToken: json['com.dcoupon.sdk.ClientToken'],
      clientSecretKey: json['com.dcoupon.sdk.ClientSecretKey'],
      clientCountry: json['com.dcoupon.sdk.ClientCountry'],
      clientDomain: json['com.dcoupon.sdk.ClientDomain'],
    );
  }
}
