import 'package:equatable/equatable.dart';

const DEFAULT_ERROR_STRING = 'An error has occurred';
const MISSING_PARAMETERS_ERROR_STRING = 'Missing parameters';

abstract class Failure extends Equatable {
  @override
  List<Object?> get props => [];
}

class ServerFailure extends Failure {
  final int? httpStatus;

  ServerFailure({
    this.httpStatus = 500,
  });

  @override
  List<Object?> get props => [
        httpStatus,
      ];
}

class IdentityApiFailure extends Failure {
  final int httpStatus;
  final int errorId;

  IdentityApiFailure({
    this.httpStatus = 500,
    this.errorId = 0,
  });

  @override
  List<Object> get props => [
        httpStatus,
        errorId,
      ];
}

class CacheFailure extends Failure {}

class DeviceFailure extends Failure {}

class NetworkFailure extends Failure {}
