import 'package:dcoupon_sdk_flutter_package/src/utils/constants.dart';

class PromotionGetPromotionsQuery {
  final int? start;
  final int? limit;
  final List<String>? categoryIds;
  final List<String>? storeIds;
  final List<String?>? retailerTokens;
  final List<String?>? companyTokens;
  final String? textSearch;
  final String? zipcode;
  final String? latitude;
  final String? longitude;
  final String? radius;
  final String? orderBy;
  final String publisherToken;

  PromotionGetPromotionsQuery({
    this.start,
    this.limit,
    this.categoryIds,
    this.storeIds,
    this.retailerTokens,
    this.companyTokens,
    this.textSearch,
    this.zipcode,
    this.latitude,
    this.longitude,
    this.radius,
    this.orderBy,
    required this.publisherToken,
  });

  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    data[Constants.START] = start;
    data[Constants.LIMIT] = limit ?? 100;
    data[Constants.CATEGORY_IDS] = categoryIds != null && categoryIds!.isNotEmpty
        ? categoryIds!.join(Constants.SEPARATOR)
        : null;
    data[Constants.STORE_IDS] = storeIds != null && storeIds!.isNotEmpty
        ? storeIds!.join(Constants.SEPARATOR)
        : null;
    data[Constants.RETAILER_TOKENS] =
        retailerTokens != null && retailerTokens!.isNotEmpty
            ? retailerTokens!.join(Constants.SEPARATOR)
            : null;
    data[Constants.COMPANY_TOKENS] =
        companyTokens != null && companyTokens!.isNotEmpty
            ? companyTokens!.join(Constants.SEPARATOR)
            : null;
    data[Constants.TEXT_SEARCH] = textSearch;
    data[Constants.ZIPCODE] = zipcode;
    data[Constants.LATITUDE] = latitude;
    data[Constants.LONGITUDE] = longitude;
    data[Constants.RADIUS] = radius;
    data[Constants.ORDER_BY] = orderBy;
    data[Constants.PUBLISHER_TOKEN] = publisherToken;
    return data;
  }
}
