import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';

abstract class CouponRepository {
  Future<Either<Failure, dynamic>> getCoupons({
    int? offset,
    int? limit,
    String? sortBy,
    List<String>? companyTokens,
    List<String>? retailerTokens,
  });

  Future<Either<Failure, dynamic>> createUserCoupons({
    required List<String> promotionTokens,
    String? latitude,
    String? longitude,
    String? saveMethod,
    String? utmSource,
    String? transId,
    String? crmId,
    required String publisherToken,
  });

  Future<Either<Failure, dynamic>> getCouponDetail({
    required String couponId,
  });

  Future<Either<Failure, dynamic>> activateCoupon({
    required String couponId,
  });

  Future<Either<Failure, dynamic>> deactivateCoupon({
    required String couponId,
  });

  Future<Either<Failure, dynamic>> getUserCouponsRetailers();

  Future<Either<Failure, dynamic>> getUserCouponsCompanies();
}
