import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';

abstract class LoyaltyRepository {
  Future<Either<Failure, dynamic>> getLoyaltyCards();

  Future<Either<Failure, dynamic>> addOrUpdateLoyaltyCard({
    required String affiliateApiToken,
    required Map<String, dynamic> formData,
  });

  Future<Either<Failure, dynamic>> deleteLoyaltyCard({
    required String affiliateApiToken,
    required String cardNumber,
  });
}
