import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';

abstract class PromotionRepository {
  Future<Either<Failure, dynamic>> getPromotions({
    int? start,
    int? limit,
    List<String>? categoryIds,
    List<String>? storeIds,
    List<String>? retailerTokens,
    List<String>? companyTokens,
    String? textSearch,
    String? zipcode,
    String? latitude,
    String? longitude,
    String? radius,
    String? orderBy,
    required String publisherToken,
  });

  Future<Either<Failure, dynamic>> getPromotionDetail({
    required String promotionToken,
    required String publisherToken,
  });

  Future<Either<Failure, dynamic>> getCategories({
    required String lang,
    required String publisherToken,
  });

  Future<Either<Failure, dynamic>> getCompanies({
    int? start,
    int? limit,
    required String publisherToken,
  });

  Future<Either<Failure, dynamic>> getRetailers({
    int? start,
    int? limit,
    required String publisherToken,
  });
}
