import 'package:dartz/dartz.dart';

import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';

abstract class RedemptionRepository {
  Future<Either<Failure, dynamic>> getUserRedemptionSummary({
    required String groupBy,
    String? startDate,
    String? endDate,
    required int gmtTimeZoneOffset,
  });

  Future<Either<Failure, dynamic>> getUserRedemptionHistory({
    int? limit,
    int? offset,
    String? startDate,
    String? endDate,
    required int gmtTimeZoneOffset,
  });

  Future<Either<Failure, dynamic>> getRedemptionDetail({
    required String redemptionId,
    required int gmtTimeZoneOffset,
  });

  Future<Either<Failure, dynamic>> getRedemptionCode();
}
