import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';

abstract class UserRepository {
  Future<Either<Failure, String>> logIn({
    required String externalId,
    String? referralCode,
  });

  Future<Either<Failure, void>> logOut();

  Future<Either<Failure, dynamic>> getUserData();

  Future<Either<Failure, dynamic>> updateUserData({
    required String alias,
    required String gender,
    required String birthdate,
  });

  Future<Either<Failure, dynamic>> unregisterUser();
}
