import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/usecases/usecase.dart';
import 'package:dcoupon_sdk_flutter_package/src/domain/repositories/coupon_repository.dart';
import 'package:equatable/equatable.dart';

class CouponGetCouponDetail
    implements UseCase<dynamic, CouponGetCouponDetailParams> {
  final CouponRepository repository;

  CouponGetCouponDetail(this.repository);

  @override
  Future<Either<Failure, dynamic>> call(
      CouponGetCouponDetailParams params) async {
    return await repository.getCouponDetail(
      couponId: params.couponId,
    );
  }
}

class CouponGetCouponDetailParams extends Equatable {
  final String couponId;

  CouponGetCouponDetailParams({
    required this.couponId,
  });

  @override
  List<Object?> get props => [
        couponId,
      ];
}
