import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/usecases/usecase.dart';
import 'package:dcoupon_sdk_flutter_package/src/domain/repositories/coupon_repository.dart';

class CouponGetUserCouponsCompanies implements UseCase<dynamic, NoParams> {
  final CouponRepository repository;

  CouponGetUserCouponsCompanies(
    this.repository,
  );

  @override
  Future<Either<Failure, dynamic>> call(NoParams params) async {
    return await repository.getUserCouponsCompanies();
  }
}
