import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/usecases/usecase.dart';
import 'package:dcoupon_sdk_flutter_package/src/domain/repositories/promotion_repository.dart';
import 'package:equatable/equatable.dart';

class PromotionGetRetailers
    implements UseCase<dynamic, PromotionGetRetailersParams> {
  final PromotionRepository repository;

  PromotionGetRetailers(this.repository);

  @override
  Future<Either<Failure, dynamic>> call(
      PromotionGetRetailersParams params) async {
    return await repository.getRetailers(
      start: params.start,
      limit: params.limit,
      publisherToken: params.publisherToken,
    );
  }
}

class PromotionGetRetailersParams extends Equatable {
  final int? start;
  final int? limit;
  final String publisherToken;

  PromotionGetRetailersParams({
    this.start,
    this.limit,
    required this.publisherToken,
  });

  @override
  List<Object?> get props => [
        start,
        limit,
        publisherToken,
      ];
}
