import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/usecases/usecase.dart';
import 'package:dcoupon_sdk_flutter_package/src/domain/repositories/user_repository.dart';

class UserUnregisterUser implements UseCase<dynamic, NoParams> {
  final UserRepository repository;

  UserUnregisterUser(
    this.repository,
  );

  @override
  Future<Either<Failure, dynamic>> call(NoParams params) async {
    return await repository.unregisterUser();
  }
}
